<template>
  <main :class="isWarning ? 'warning' : ''">
    <step-header
      :step="currentStep"
      :pending="pending"
      @stepDone="stepDone"
    />
    <step-list
      v-if="!isWarning"
      :steps="remainingSteps"
      :current-step="currentStep"
    />
    <call-passenger :step="currentStep" />
  </main>
</template>

<script>
import { mapGetters } from 'vuex';
import stepHeader from '~/components/step/header.vue';
import stepList from '~/components/step/list.vue';
import callPassenger from '~/components/elements/call-passenger.vue';

export default {
  components: {
    stepHeader,
    stepList,
    callPassenger,
  },
  data() {
    return {
      driverId: this.$auth.user.id,
      pending: false,
    };
  },
  computed: {
    ...mapGetters({
      steps: 'steps/steps',
      workStatus: 'status/workStatus',
      rideStatus: 'status/rideStatus',
      isWarning: 'steps/alert',
      campus: 'context/campus',
    }),
    currentStep() {
      return this.steps[0];
    },
    remainingSteps() {
      return this.steps.filter((_, index) => index !== 0);
    },
  },
  methods: {
    async stepDone(step) {
      this.pending = true;
      await this.$api.query('steps')
        .setCampus(this.campus.id)
        .setDriver(this.$auth.user.id)
        .delete(step.id);
      this.pending = false;
    },
  },
};
</script>

<style lang="scss" scoped>
  @import "~assets/css/head";

  main {
    &.warning {
      background-color: $red;
      color: $white;
      height: inherit;
      * {
        background-color: inherit;
        color: inherit;
      }
    }
    section {
      padding: 2em;
    }
  }
</style>
